<?php

namespace Drupal\navigation_blocks\Plugin\Block;

/**
 * Provides a 'EntityCanonicalBackButton' block.
 *
 * @Block(
 *  id = "entity_canonical_back_button",
 *  deriver = "Drupal\navigation_blocks\Plugin\Deriver\EntityCanonicalBackButtonDeriver"
 * )
 */
class EntityCanonicalBackButton extends BackButton {

  /**
   * {@inheritdoc}
   *
   * @throws \Drupal\Core\Entity\EntityMalformedException
   * @throws \Drupal\Component\Plugin\Exception\PluginException
   */
  public function build() {
    $build = $this->backButtonManager->getPreferredLink($this->getPreferredBackPaths(), self::BACK_BUTTON_TEXT, $this->useJavascript());

    if (!empty($build)) {
      return $build;
    }

    if($this->backButtonManager->validateCanonicalPath()) {
      return [];
    }

    /** @var \Drupal\Core\Entity\EntityInterface $entity */
    $entity = $this->getContextValue('entity');

    if ($entity) {
      $link = $entity->toLink()->toRenderable();
      $this->backButtonManager->addLinkAttributes($link);
      return $link;
    }

    return $this->backButtonManager->getLink($this->getLinkUrl(), $this->getLinkText());
  }

}
